//
// Created by gwall on 1/9/18.
//

#ifndef TX2_COMPRESSION_ENCODER_HELPERS_H
#define TX2_COMPRESSION_ENCODER_HELPERS_H

#include "video_encode.h"

int test_error(bool cond, const char *str, context_t &ctx);

int cleanup(context_t &ctx, int error);

void abort(context_t *ctx);

//Initialise CRC Rec and creates CRC Table based on the polynomial.
Crc* InitCrc(unsigned int CrcPolynomial);

//Calculates CRC of data provided in by buffer.
void CalculateCrc(Crc *phCrc, unsigned char *buffer, uint32_t count);

//Closes CRC related handles.
void CloseCrc(Crc **phCrc);

int write_encoder_output_frame(std::ofstream * stream, NvBuffer * buffer);

bool encoder_capture_plane_dq_callback(struct v4l2_buffer *v4l2_buf, NvBuffer * buffer,
                                  NvBuffer * shared_buffer, void *arg);

int setup_encoder(context_t& ctx);

#endif //TX2_COMPRESSION_ENCODER_HELPERS_H
