//
// Created by gwall on 1/10/18.
//

#include "video_encoder.h"
#include "png_helpers.h"
#include <vector>

#define PNG_FOLDER "../png_encode/test_images/"
#define OUTPUT "test.h264"

double getUnixTime(void) {
    struct timespec tv;

    if (clock_gettime(CLOCK_REALTIME, &tv) != 0) return 0;

    return (tv.tv_sec + (tv.tv_nsec / 1000000000.0));
}

int main(int argc, char *argv[]) {
    double t0 = getUnixTime();
    double t1, t2;


    vector<image_t> images = vector<image_t>();
    cout << "Reading Images" << endl;
    get_images(string(PNG_FOLDER), images, 12);

    VideoEncoder encoder(images[0].height, images[0].width, OUTPUT);
    cout << "Starting Compression" << endl;
    t1 = getUnixTime();
    for (auto &image : images) {
        encoder.compressYFrame((uint8_t *) image.data);
        free(image.data);
    }
    cout << "Cleaning Up" << endl;
    encoder.compressYFrame(nullptr);

    t2 = getUnixTime();

    cout << "Encoder Time:" << t2 - t1 << " Total Time:" << t2 - t0 << " Per Frame Time:" << (t2 - t1) / images.size()
         << endl;



    return 0;
}

