//
// Created by gwall on 1/10/18.
//

#ifndef TX2_COMPRESSION_VIDEO_ENCODER_H
#define TX2_COMPRESSION_VIDEO_ENCODER_H

#include "video_encode.h"

class VideoEncoder {
public:

    VideoEncoder(unsigned height, unsigned width, char* output_fname);

    void compressYFrame(uint8_t* y_bytes);

    void compressYUV420Frame(uint8_t* yuv_bytes);

    ~VideoEncoder();

private:
    int setupContext();
    //count the number of frames processed
    unsigned frame_count;
    //need to queue up the appropriate number of frames before compression can start
    //int enqueueFrame(uint8_t *yuv_bytes);
    //after the required number of frames are enqueued this method is called instead
    int encodeFrame(uint8_t* yuv_bytes);
    void copyYuvToBuffer(uint8_t *yuv_bytes, NvBuffer &buffer);

    context_t ctx;
};

#endif //TX2_COMPRESSION_VIDEO_ENCODER_H
